SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'SachinKulkarni 1/20/2013 16:34'!
initialize 
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!LOCell methodsFor: 'accessing' stamp: 'SachinKulkarni 1/20/2013 18:54'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'SachinKulkarni 1/20/2013 18:55'!
mouseUp: anEvent
	mouseAction value! !

SimpleSwitchMorph subclass: #NameOfSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

LOGame class
	instanceVariableNames: 'cellsPerSide'!

LOGame class
	instanceVariableNames: 'cellsPerSide'!

!LOGame methodsFor: 'initialization' stamp: 'SachinKulkarni 1/20/2013 18:33'!
cellsPerSide 
	"This method initializes the number of cells per game"
	^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'SachinKulkarni 1/20/2013 17:22'!
initialize 
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n)@(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'event handling' stamp: 'SachinKulkarni 1/20/2013 19:06'!
mouseMove: anEvent! !

!LOGame methodsFor: 'game logic' stamp: 'SachinKulkarni 1/20/2013 19:03'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my-onscrees
	  representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i-1)*c width) @ ((j-1)*c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c.! !

!LOGame methodsFor: 'game logic' stamp: 'SachinKulkarni 1/20/2013 18:50'!
toggleNeighboursOfCellAt: i at: j
	(i>1) ifTrue: [(cells at: i - 1 at: j) toggleState].
	(i < self cellsPerSide ) ifTrue: [(cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [(cells at: i at: j - 1) toggleState ].
	(j < self cellsPerSide ) ifTrue: [(cells at: i at: j + 1) toggleState ].! !
